/*
 *  util.c
 *
 *  MyQQ utilities
 *
 *  Copyright (C) 2008  Huang Guan
 *
 *  2008-7-15 Created.
 *
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#ifdef __WIN32__
#include <io.h>
#else
#include <sys/stat.h>
#endif
#include <time.h>
#include "debug.h"
#include "qqdef.h"
#include "util.h"

int mkdir_recursive( char* path )
{
	char *p;
	if( access( path, 0 ) == 0 )
		return 0;
	for( p=path; *p; p++ ){
		if( p>path && *p == '/' ){
			*p = 0;
			if( access( path, 0 ) != 0 ){
#ifdef __WIN32__
				mkdir( path );
#else
				if( mkdir( path, S_IRWXU ) != 0 )
					return -1;
#endif
			}
			*p = '/';
		}
	}
#ifdef __WIN32__
	return mkdir( path );
#else
	return mkdir( path, S_IRWXU );
#endif
}

int trans_faces( char* src, char* dst, int outlen )
{
	char * p, *q;
	p = src;	q = dst;
	while( *p ){
		if( *(p++) == 0x14 ){
			if( (int)(q-dst) < outlen - 10 )
				q += sprintf( q, "[face:%u]", *(p++) );
		}else{
			if( (int)(q-dst) < outlen )
				*(q++) = *(p-1);
		}
	}
	*q = 0;
	return (int)(q-dst);
}
